/* This program demonstrates the use
   of function pointers
*/

#include <stdio.h>

void add(int a, int b){
    printf("Addition is %d\n", a+b);
}

void subtract(int a, int b){
    printf("Subtraction is %d\n", a-b);
}

void multiply(int a, int b){
    printf("Multiplication is %d\n", a*b);
}
 
int main()
{
    // fun_ptr_arr is an array of function pointers
    // array of pointers is our next topic
    void (*fun_ptr_arr[])(int, int) = {add, subtract, multiply};
    unsigned int ch, a = 15, b = 10;
 
    printf("Enter Choice: 0 for add, 1 for subtract and 2 "
            "for multiply\n");
    scanf("%d", &ch);
 
    if (ch > 2){
    	printf("psss... wrong choice\n"); 
	return 0;
    }
 
    (*fun_ptr_arr[ch])(a, b); // see how compact it is to call funcs
 
    return 0;
}
