/* This program demonstrates the offset 
   and subscripting notations for pointers
*/

#include <stdio.h>
#define ARRAY_SIZE 4

int main(void){
	
	int v[] = {10, 20, 30, 40, 50};
	int *vPtr = v; //array name stands for its base address!!
	int i;

	puts( "Array v printed with: \nArray subscript notation\n");
	for (i=0; i<ARRAY_SIZE; ++i){
		printf( "v[%d] = %d\n", i, v[i]);
	}

	puts( "\nPointer offset notation\n");
	for (i=0; i<ARRAY_SIZE; ++i){
		printf( "*(v+%d) = %d\n", i, *(v+i));
	}

	puts( "\nPointer subscript notation\n");
	for (i=0; i<ARRAY_SIZE; ++i){
		printf( "vPtr[%d] = %d\n", i, vPtr[i]);
	}
	
	puts( "\nPointer offset notation\n");
	for (i=0; i<ARRAY_SIZE; ++i){
		printf( "*(vPtr+%d) = %d\n", i, *(vPtr+i));
	}	
	
	return 0;
}
